/*
    Slider.pde
    Copyright (C) 2011
    Authors: Arun I, Hari Prasad Gokul R, Prabhu P, Sravan M Baddepudi, Sudhakar M K, Suresh Kannan M
    email: theroarofthedragon@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

//class to create a linear slider

class Slider
{
  //Position and dimensions of the slider
  int xPos,yPos;
  int widthSlider,heightSlider;
  int widthKnob;
  
  //Values
  int minValue,maxValue;
  float curValue;
  int range;
  
  Slider(int xPos_,int yPos_,int widthSlider_,int heightSlider_,int minValue_,int maxValue_)
  {
    xPos=xPos_;
    yPos=yPos_;
    widthSlider=widthSlider_;
    heightSlider=heightSlider_;
    minValue=minValue_;
    maxValue=maxValue_;
    curValue=0;
    widthKnob=20;
    range=maxValue-minValue;
    
    drawMe();
  }
  
  void drawMe()
  {
    pushMatrix();
    translate(xPos,yPos);
    
    fill(255);
    stroke(255);
    strokeWeight(1);
    rect(-widthKnob/2,-heightSlider/2,widthSlider+widthKnob,heightSlider);
    
    stroke(0);
    line(0,0,widthSlider,0);
    float knobPos=map(curValue,minValue,maxValue,0,widthSlider);
    rect(knobPos-widthKnob/2,-heightSlider/2,widthKnob,heightSlider);
    
    popMatrix();
  }
  
  void update()
  {
    if (overKnob())
    {
      curValue=curValue+(mouseX-pmouseX)*0.25;
      curValue=curValue>maxValue?maxValue:curValue;
      curValue=curValue<minValue?minValue:curValue;
      drawMe();
    }
  }
  
  boolean overKnob()
  {
    int knobPos=(int)map(curValue,minValue,maxValue,0,widthSlider);
    boolean over=(mouseX>xPos+knobPos-widthKnob/2 && mouseX<xPos+knobPos+widthKnob/2 && mouseY<yPos+heightSlider/2 && mouseY>yPos-heightSlider/2);
    return(over);
  }
}
